include <iostream.h>
#define TRUE 1
#define FALSE 0
typedef int Boolean;
typedef struct L *Lref; //:    .
typedef struct T *Tref; //:    .
//   .
typedef struct L 
{
  int Key;    //  .
  int Count;  // .
  int Count1; //  .
  Tref Pred;  //   ,  "".
  Tref Trail; //   ,  "".
  Lref Next;  //     
              //  .
} Leader;

//   .
typedef struct T 
{
  Lref Id; 
  Tref Next; 
} Trailer;

class Spisok {
  private:
    Lref Head; //    .
    Lref Tail; //    
               //    .
    Lref SearchGraph(int);
    Lref Search(int);
  public:
    Spisok () {//   .
               Head = Tail = new (Leader); }
    ~Spisok(); //.
    void MakeGraph();
    void AddGraph(int, int);
    void DeleteGraph(int, int);
    void PrintGraph();
    void DeleteY(int);
    void Free1Graph(Lref *, Lref *);
    void Free2Graph(Tref *); 
};

void main ()
{
  Spisok A;
  int x,y; //   .

  //    .
  A.MakeGraph ();
  A.PrintGraph (); cout<<endl;
  cout<< "    ...\n";
  cout<< "  : "; cin>>x;
  cout<< "  : "; cin>>y;
  A.AddGraph (x,y);
  A.PrintGraph (); cout<<endl;
  cout<< "    ...\n";
  cout<< "    : "; cin>>x;
  cout<< "    : "; cin>>y;
  A.AddGraph (x,y);
  A.AddGraph (y,x);
  A.PrintGraph (); cout<<endl;
  cout<< "    ...\n";
  cout<< "  : "; cin>>x;
  cout<< "  : "; cin>>y;
  A.DeleteGraph (x,y);
  A.PrintGraph (); cout<<endl;
  cout<< "    ...\n";
  cout<< "    : "; cin>>x;
  cout<< "    : "; cin>>y;
  A.DeleteGraph (x,y);
  A.DeleteGraph (y,x);
  A.PrintGraph (); cout<<endl;
  cout<< "  : "; cin>>y;
  A.DeleteY (y);
  A.PrintGraph (); cout<<endl;
}

Spisok::~Spisok()
{
  //  .
  Lref t = Head;
  while (t!=Tail)
  { Free2Graph (&(*t).Trail); t = (*t).Next; }
  Free1Graph (&Head,&Tail);
  delete Tail;
}

Lref Spisok::SearchGraph (int w)
//      
//  w.    ,   
//  . Head -    .
{
  Lref h;

  h = Head; (*Tail).Key = w;
  while ((*h).Key!=w) h = (*h).Next;
  if (h==Tail)
  //        w.
  //     Head.
  { Tail = new (Leader); (*h).Count = (*h).Count1 = 0; 
    (*h).Trail = (*h).Pred = NULL; (*h).Next = Tail; }
  return h;
}

Lref Spisok::Search (int w)
//      
// w.   ,    NULL .
{
  Lref h = Head;
  (*Tail).Key = w; // " ".
  while ((*h).Key!=w) h = (*h).Next;
  if (h==Tail) //        w.
    h = NULL;
  return h;
} 

void Spisok::MakeGraph ()
//   Head    
//,   .
{
  int x,y;
  Lref p,q;    // .
  Tref t,r;    //  .
  Boolean Res; //  .

  cout<<"   : ";
  cin>>x;
  while (x!=0)
  {
    cout<<"   : "; cin>>y;
    //,      (x,y)?
    p=SearchGraph (x); q=SearchGraph (y);
    r = (*p).Trail; Res = FALSE; 
    while ((r!=NULL)&&(!Res)) 
      if ((*r).Id==q) Res = TRUE; 
      else r = (*r).Next; 
    if (!Res) //  ,     .
    { t = new (Trailer); (*t).Id = q; 
      (*t).Next = (*p).Trail; (*p).Trail = t; (*q).Count++; 
      t = new (Trailer); (*t).Id = p;
      (*t).Next = (*q).Pred;  (*q).Pred = t; (*p).Count1++; } 
    cout<<"   : "; cin>>x;
  }
}

void Spisok::AddGraph (int x,int y)
//  (x,y) (   !)   
//,    Head.
{
  Lref p,q;    // .
  Tref t,r;    // .
  Boolean Res; //     .

  //,      (x,y)? 
  p=SearchGraph (x); q=SearchGraph (y);
  r = (*p).Trail; Res = FALSE;
  while ((r!=NULL)&&(!Res)) 
    if ((*r).Id==q) Res = TRUE; else r = (*r).Next;
  if (!Res)
  { //  ,     .
    t = new (Trailer); (*t).Id = q; (*t).Next = (*p).Trail; 
    (*p).Trail = t; (*q).Count++;
    t = new (Trailer); (*t).Id = p;
    (*t).Next = (*q).Pred;  (*q).Pred = t; (*p).Count1++; 
  }
} 

void Spisok::DeleteGraph (int x,int y)
//   Head   
//,   
//    (x,y).
{
  Lref p,q;    // .
  Tref t,r;    // .
  Boolean Res; //     .

  //,      (x,y)?
  p=Search (x); q= Search (y);
  if ((p!=NULL)&&(q!=NULL))
  { // x  y   .
    r = (*p).Trail; Res = FALSE; 
    while ((r!=NULL)&&(!Res)) 
      if ((*r).Id==q) Res = TRUE; 
      else r = (*r).Next; 
   if (Res) //  ,   .
   if (r==(*p).Trail)
     { (*p).Trail = (*(*p).Trail).Next; delete r; (*q).Count--; } 
   else 
    {
      t = (*p).Trail; 
      while ((*t).Next!=r) t = (*t).Next;
      (*t).Next = (*(*t).Next).Next; delete r; (*q).Count--; }
    }
} 

void Spisok::PrintGraph ()
//   ,   
//Head    .
{
  Lref p; // .
  Tref q; // .

  p = Head;
  while (p!=Tail)
  {
    cout<<(*p).Key<<"(("; q = (*p).Trail; 
    while (q!=NULL) 
    { cout<<(*(*q).Id).Key<<" "; q = (*q).Next; } 
    cout<<")("; 
    q = p->Pred;
    while (q!=NULL)
    { cout <<(*(*q).Id).Key<<" "; q = q->Next; }
    cout<<"))";
    p = (*p).Next; cout<<" ";
  }
}

void Spisok::DeleteY (int y)
//   Head   , 
//     y.
{ 
  Lref p,q; // .
  Tref r,s; // .
  int x;    // .
  //   (x,y),     y.
  p = Head; 
  while (p!=Tail) 
  { x = (*p).Key; DeleteGraph (x,y); p = (*p).Next; } 
  //    y.
  p=SearchGraph (y); r = (*p).Trail;
  while (r!=NULL) 
  { s = r; r = (*r).Next; (*(*s).Id).Count++; delete s; } 
  // ,   y,     .
  q = Head; 
  if (q==p) { Head = (*Head).Next; delete q; } 
  else { 
    while ((*q).Next!=p) q = (*q).Next; 
    (*q).Next = (*p).Next; delete p; }
} 

void Spisok::Free1Graph (Lref *Head, Lref *Tail)
//  ,   , 
//   *Head.
{
  if (*Head!=*Tail)
  { Free1Graph (&(**Head).Next,Tail); delete *Head; *Head = NULL; }
} 

void Spisok::Free2Graph (Tref *X)
//  ,   , 
//   *X.
{
  if (*X!=NULL)
  { Free2Graph (&(**X).Next); delete *X; *X = NULL; }
}
